function love.load()
	lg = love.graphics
	lg.setLineStyle("rough")
	love.keyboard.setKeyRepeat(false)
	--solving and simulating d2u/dt2 = c2 d2u/dx2
	--initializing number line
	x = {}
	x[1] = {} -- function
	x[2] = {} -- first spatial derivative
	x[3] = {} -- second spatial derivative

	x[4] = {} -- first time derivative
	x[5] = {} -- second time derivative

	foam = {}
	steps = lg.getWidth()
	function gauss(x,m,s)
		f = math.exp(-0.5*math.pow(x-m,2)/(s*s))
		return f
	end
	--Randbedingungen:
	function reset()
		startval = 0
		startval2 = 0
		x[1][1] = startval2
		x[1][steps+1] = startval2
		x[2][1] = 0
		x[2][steps+1] = 0
		x[3][1] = 0
		x[3][steps+1] = 0
		x[4][1] = 0
		foam[1] = 0
		for i=2,steps do
			x[1][i] = startval2
			x[2][i] = startval
			x[3][i] = startval
			x[4][i] = startval
			foam[i] = 0
			--x[math.floor(steps/2)] = 100
		end
	end


	--x[math.floor(steps/2)] = 50

	c = 10 -- speed
	k = 0 -- damping


	function slope(a,j)
	--right way
	y1 = (-a[j+1]) - (-a[j])
	y2 = (-a[j]) - (-a[j-1])
	return (y1+y2)/2
	--[[ --wrong way
	y1 = (a[j+1]) - (a[j])
	y2 = (a[j]) - (a[j-1])
	return (y1+y2)/2]]
	end

	bottomline = math.floor(lg.getHeight()/2)
	reset()
	flagu = true
	flagup = false
	flagupp = false
	flagut = false

	bellx = 0
	belly = 0
	belly_ = 0
end

function love.mousepressed(a,b,button)
	bellx = a
	belly_ = b
	belly = bottomline - b -startval2

end

function love.mousereleased(a,b,button)
	deltax = math.abs(bellx - a)
	if deltax == 0 then deltax = 1 end
	for i=2,steps do
		x[1][i] = x[1][i] + belly*gauss(i,bellx,deltax)
	end
end

function love.update(dt)
	for i=2,steps do

		x[2][i] = slope(x[1],i)
		x[3][i] = slope(x[2],i)

		x[5][i] = c*c*x[3][i] - k*x[2][i]
		x[4][i] =  x[4][i] + x[5][i]*dt
		x[1][i] = x[1][i] + x[4][i]*dt

		foam[i] = foam[i] -dt
		if foam[i] <= 0 then
			foam[i] = 0
		end
		if math.abs(x[2][i]) > 70 then
			foam[i] = 0.5
		end
	end
	--[[
	if love.mouse.isDown(1) then
		mx,my = love.mouse.getPosition()
		x[mx] = bottomline-my
	end]]
	if love.keyboard.isDown("r") then
		reset()
	end
	if love.keyboard.isDown("+") then
		c = c + 0.1
	end
	if love.keyboard.isDown("-") then
		c = c - 0.1
	end
	if love.keyboard.isDown("2") then
		k = k + 0.01
	end
	if love.keyboard.isDown("1") then
		k = k - 0.01
	end
	deltax_ = math.abs(bellx-love.mouse.getX())
	if deltax_ == 0 then deltax_ = 1 end
end

function love.draw()
	lg.setColor(255,255,255)
	lg.print("Press +/- to change wave speed; Press r to reset; Click to change wave form; Press 1/2 to change damping", 50,50)
	lg.print("c = " .. c, 50,60)
	lg.print("k = " .. k, 150,60)
	lg.line(0,bottomline,steps,bottomline)


	lg.setColor(0,0,255)
	for i=1,steps do
		lg.line(i-1,bottomline,i-1,bottomline-x[1][i])
		if foam[i] > 0 then
			lg.setColor(200,200,200)
			lg.points(i-1,bottomline-x[1][i])
			lg.setColor(0,0,255)
		end
	end

	if love.mouse.isDown(1) then
		X = love.mouse.getX()
		Y = love.mouse.getY()
		if belly_ < (bottomline) then
			lg.setColor(120,120,120)
		else
			lg.setColor(200,50,50)
		end
		lg.line(bellx,belly_, X,Y)
		lg.print(deltax_,X + 20, Y + 20)
	end
end
